#include "./crave.h"

/* Function to print a test structure */
void print_tests(info, n)
INFO *info;
int n;
{
  TEST_STR **tests=info->tests, *tst;
  int i, j;

  for (i=0; i<info->n_test; i++) {
    tst = tests[i];  
    printf("which=%d, nperm=%d, pvalue=%g, cont=%d, len=%d\n", tst->which, tst->nperm, tst->pvalue, tst->cont, tst->len);
    j = MIN(n, tst->len);
    if (!j) j = 1;
    print_dVec(tst->obs, j, "obs");
    print_dVec(tst->test, j, "test");
    print_iVec(tst->n_gt_obs, j, "n_gt_obs");
    printf("\n");
  }

} /* END: print_tests */

/* Function to compute the mean of a binary vector */
double mean_bvec(vec, n)
binary *vec;
int n;
{
  double sum=0.0, ret;
  int i;

  for (i=0; i<n; i++) sum += (double) vec[i];
  ret = sum/n;

  return(ret);

} /* END: mean_vec */


void print_bVec(vec, n, name)
binary *vec;
int n;
char name[10];
{
  int i;
  printf("%s \n", name);
  for (i=0; i<n; i++) {
    printf(" %d ", vec[i]);
  }
  printf("\n \n");
}

/* Function to print a genotype vector */
void print_gVec(vec, n, name)
genoType *vec;
int n;
char *name;
{
  int i;

  printf("%s \n", name);
  for (i=0; i<n; i++) printf("%d ", vec[i]);  
  printf("\n");

} /* END: print_gVec */

void print_iVec(vec, n, name)
int *vec;
int n;
char name[10];
{
  int i;
  printf("%s \n", name);
  for (i=0; i<n; i++) {
    printf(" %d ", vec[i]);
  }
  printf("\n \n");
}

void print_dVec(vec, n, name)
double *vec;
int n;
char name[10];
{
  int i;
  printf("%s \n", name);
  for (i=0; i<n; i++) {
    printf(" %g ", vec[i]);
  }
  printf("\n \n");
}

void print_cVec(vec, n, name)
char **vec;
int n;
char name[10];
{
  int i;

  printf("%s \n", name);
  for (i=0; i<n; i++) printf(" %s ", vec[i]);
  printf("\n \n");
}

void print_iMat(mat, nr, nc, name)
int **mat;
int nr, nc;
char name[10];
{
  int i, j;
  printf("%s \n", name);
  for (i=0; i<nr; i++) {
    for (j=0; j<nc; j++) printf(" %d ", mat[i][j]);
    printf("\n");
  }
  printf("\n \n");
}

void print_dMat(mat, nr, nc, name)
double **mat;
int nr, nc;
char name[10];
{
  int i, j;
  printf("%s \n", name);
  for (i=0; i<nr; i++) {
    for (j=0; j<nc; j++) printf(" %g ", mat[i][j]);
    printf("\n");
  }
  printf("\n \n");
}



/* Function to get the next token */
char * old_next_token(str, n, sep)
char *str, sep;
long n;
{
  int i;
  char *pc;

  if (str == NULL) return(NULL);
  n = MIN(n, strlen(str));
  for (i=0, pc=str; i<n; i++, pc++) {
    if (*pc == sep) {
      pc++;
      return(pc);
    }
  }
  return(NULL);

} /* END: old_next_token */

