/***************************************************************
                                                             
                    CRAVE                  
                                                              
 This file is distributed under the GNU General Public        
 License, Version 2. See the file COPYING.txt for more    
 details                                                      
                                                              
****************************************************************/

#include "./crave.h"

/* Function to determine if file is a .gz file */
int is_gz_file(datafile)
char *datafile;
{
  int len, ret=0;
  
  len = (int) strlen(datafile);
  if (len > 3) {
    if ((datafile[len-3] == '.') && (datafile[len-2] == 'g') && (datafile[len-1] == 'z')) ret = 1;
  }

  return(ret);

} /* END: is_gz_file */


void my_fopen(datafile, gfpt) 
char *datafile;
FILEFPT *gfpt;
{
  if (!gfpt->gzFlag) {
    gfpt->fpt = open_file(datafile, "r");
  } else {
    #if WITH_ZLIB
    gfpt->gzfpt = gzopen(datafile, "r");
    if (gfpt->gzfpt == NULL) {
      printf_s("\n Error opening file: %s \n", datafile);
      exit(0);
    }
    #else
    gfpt->gzfpt = open_file(datafile, "r");
    #endif
  }

} /* END: my_fopen */  

void my_fclose(gfpt) 
FILEFPT *gfpt;
{
  if (!gfpt->gzFlag) {
    if (gfpt->fpt) {
      fclose(gfpt->fpt);
      gfpt->fpt = NULL;
    }
  } else {
    #if WITH_ZLIB
      if (gfpt->gzfpt) {
        gzclose(gfpt->gzfpt);
        gfpt->gzfpt = NULL;
      }
    #else
     if (gfpt->gzfpt) {
        fclose(gfpt->gzfpt);
        gfpt->gzfpt = NULL;
      }
    #endif
  }

} /* END: my_fclose */  

char * my_fgets(line, size, gfpt)
char *line;
size_t size;
FILEFPT *gfpt;
{
  char *ret;

  if (!gfpt->gzFlag) {
    ret = fgets(line, size, gfpt->fpt);
  } else {
    #if WITH_ZLIB
    ret = gzgets(gfpt->gzfpt, line, size);
    #else
    ret = fgets(line, size, gfpt->gzfpt);
    #endif
  }

  return(ret);

} /* END: my_fgets */



